import classnames from "classnames";
import { Component } from "react";

import { Block, View, Button, PageMeta } from "@tarojs/components";

import { Popup } from "@antmjs/vantui";

import "./popup.less";
import "./popup-drawer.less";
/*** props
 * isLarge            是否大尺寸
 * isShow             是否显示
 * isClose            右上角关闭图标
 * postion            抽屉弹出位置  left right top bottom
 * title              弹窗标题
 * content            弹窗内容
 * confirmButtonText  确定按钮
 * textAlgin          文本对齐 left  right  center
 * @confirm           关闭回调
 * ***/
export default class PopupDrawer extends Component<any, any> {
  constructor(props) {
    super(props);
    this.state = {
      name: "抽屉组件",
    };
  }

  async onLoad() {}
  componentDidMount() {}

  componentWillUnmount() {}

  componentDidShow() {}

  componentDidHide() {}

  async initData() {}

  onClose = () => {
    this.props.close();
  };

  onConfirm = () => {
    this.props.confirm();
  };

  onClickStop = (e) => {
    e.stopPropagation();
  };

  render() {
    let {
      title,
      content,
      confirmButtonText,
      textAlgin,
      isShow,
      isClose,
      isLarge,
      postion,
    } = this.props;

    return (
      <Block>
        <PageMeta pageStyle={isShow ? "overflow: hidden;" : ""} />
        <Popup
          show={isShow}
          closeOnClickOverlay={false}
          position={postion || "bottom"}
          round
          overlayStyle="width: 100vw;padding: 0;"
          onClick={this.onClickStop}
        >
          {isClose && (
            <View
              className="at-icon at-icon-close common-close"
              onClick={this.onClose}
            ></View>
          )}
          <View
            className={classnames(
              "common-box",
              "drawer-box",
              "common-big-large"
            )}
            style="margin: auto;"
          >
            <View
              className={classnames("common-popup-title", "drawer-popup-title")}
            >
              {title}
            </View>
            <View className="common-popup-content-box">
              <View
                className={classnames("common-popup-content", {
                  "text-left": textAlgin === "left",
                  "text-right": textAlgin === "right",
                  "text-center": textAlgin === "center",
                })}
              >
                {content}
              </View>
            </View>
            <View className="common-popup-btns">
              <Button className="drawer-popup-btn" onClick={this.onConfirm}>
                {confirmButtonText}
              </Button>
            </View>
          </View>
        </Popup>
      </Block>
    );
  }
}
